<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBookFlightSegmentTypeBookingClassAvail ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfBookFlightSegmentTypeBookingClassAvail extends AbstractStructArrayBase
{
    /**
     * The BookingClassAvail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgBookingClassAvail[]
     */
    public $BookingClassAvail;
    /**
     * Constructor method for ArrayOfBookFlightSegmentTypeBookingClassAvail
     * @uses DgArrayOfBookFlightSegmentTypeBookingClassAvail::setBookingClassAvail()
     * @param \dgsoft\StructType\DgBookingClassAvail[] $bookingClassAvail
     */
    public function __construct(array $bookingClassAvail = array())
    {
        $this
            ->setBookingClassAvail($bookingClassAvail);
    }
    /**
     * Get BookingClassAvail value
     * @return \dgsoft\StructType\DgBookingClassAvail[]|null
     */
    public function getBookingClassAvail()
    {
        return $this->BookingClassAvail;
    }
    /**
     * Set BookingClassAvail value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgBookingClassAvail[] $bookingClassAvail
     * @return \dgsoft\ArrayType\DgArrayOfBookFlightSegmentTypeBookingClassAvail
     */
    public function setBookingClassAvail(array $bookingClassAvail = array())
    {
        foreach ($bookingClassAvail as $arrayOfBookFlightSegmentTypeBookingClassAvailBookingClassAvailItem) {
            // validation for constraint: itemType
            if (!$arrayOfBookFlightSegmentTypeBookingClassAvailBookingClassAvailItem instanceof \dgsoft\StructType\DgBookingClassAvail) {
                throw new \InvalidArgumentException(sprintf('The BookingClassAvail property can only contain items of \dgsoft\StructType\DgBookingClassAvail, "%s" given', is_object($arrayOfBookFlightSegmentTypeBookingClassAvailBookingClassAvailItem) ? get_class($arrayOfBookFlightSegmentTypeBookingClassAvailBookingClassAvailItem) : gettype($arrayOfBookFlightSegmentTypeBookingClassAvailBookingClassAvailItem)), __LINE__);
            }
        }
        $this->BookingClassAvail = $bookingClassAvail;
        return $this;
    }
    /**
     * Add item to BookingClassAvail value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgBookingClassAvail $item
     * @return \dgsoft\ArrayType\DgArrayOfBookFlightSegmentTypeBookingClassAvail
     */
    public function addToBookingClassAvail(\dgsoft\StructType\DgBookingClassAvail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgBookingClassAvail) {
            throw new \InvalidArgumentException(sprintf('The BookingClassAvail property can only contain items of \dgsoft\StructType\DgBookingClassAvail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->BookingClassAvail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgBookingClassAvail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgBookingClassAvail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgBookingClassAvail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgBookingClassAvail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgBookingClassAvail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BookingClassAvail
     */
    public function getAttributeName()
    {
        return 'BookingClassAvail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfBookFlightSegmentTypeBookingClassAvail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
